extends Label


#var times = []
var fps = 60.0
var old_usec = Time.get_ticks_usec()
var use_script_fps = false


func get_fps() -> float:
	if use_script_fps:
		return fps
	else:
		return Engine.get_frames_per_second()


func _input(event: InputEvent) -> void:
	if event.is_action_pressed("toggle_script_fps"):
		use_script_fps = not use_script_fps
	if event.is_action_pressed("increase_target_fps"):
		Engine.max_fps += 10
	if event.is_action_pressed("decrease_target_fps"):
		Engine.max_fps = max(0, Engine.max_fps - 10)


func _process(delta: float) -> void:
	var usec := Time.get_ticks_usec()
	var ratio: float = 50 * (usec - old_usec) * 0.000_000_1
	fps = fps * (1 - ratio) + ratio * 1_000_000.0 / (usec - old_usec)

	old_usec = usec

	# Old array-based implementation (less efficient, less smooth).
#	var last_old_idx = 0
#	for time_idx in times.size():
#		if times[time_idx] < Time.get_ticks_usec() - 1_000_000:
#			last_old_idx = time_idx
#		else:
#			break
#
#	for i in last_old_idx:
#		times.pop_front()
#	times.push_back(Time.get_ticks_usec())

	text = "[%-6s] %d FPS (%.1f mspf)\nMax FPS: %d (+ V-Sync)" % ["Script" if use_script_fps else "Core", round(get_fps()), 1000.0 / get_fps(), Engine.max_fps]
